import { NgPackageConfig } from '../ng-package.schema';
/** POVO (plain-old value object) of the Angular package being built. */
export declare class NgPackage {
    private basePath;
    /** Contents of `ng-package.json` file. */
    ngPackageJson: NgPackageConfig;
    /** Contents of `package.json` file. */
    packageJson: any;
    constructor(basePath: string, 
        /** Contents of `ng-package.json` file. */
        ngPackageJson: NgPackageConfig, 
        /** Contents of `package.json` file. */
        packageJson: any);
    readonly dest: string;
    readonly src: string;
    readonly workingDirectory: string;
    readonly flatModuleFileName: string;
    readonly libExternals: Object;
    /** Package meta information */
    readonly meta: {
        name: string;
        scope?: string;
    };
    /** Build artefacts */
    readonly artefacts: {
        main: string;
        module: string;
        es2015: string;
        typings: string;
    };
}
